from ophyd import (EpicsSignal, EpicsSignalRO)

from .. import (RecordBase, _register_record_type,
                FieldComponent as Cpt)


@_register_record_type('fanout')
class FanoutRecord(RecordBase):
    alarm_status = Cpt(EpicsSignalRO, '.STAT')
    link_selection = Cpt(EpicsSignal, '.SELN')

    # - links
    forward_link_1 = Cpt(EpicsSignal, '.LNK1$', string=True)
    forward_link_2 = Cpt(EpicsSignal, '.LNK2$', string=True)
    forward_link_3 = Cpt(EpicsSignal, '.LNK3$', string=True)
    forward_link_4 = Cpt(EpicsSignal, '.LNK4$', string=True)
    forward_link_5 = Cpt(EpicsSignal, '.LNK5$', string=True)
    forward_link_6 = Cpt(EpicsSignal, '.LNK6$', string=True)
    link_selection_loc = Cpt(EpicsSignal, '.SELL$', string=True)
    select_mechanism = Cpt(EpicsSignal, '.SELM')
